## castle-game-engine 6.4+dfsg1

=== Makefile ===
# Most useful targets:
#
#   all (default target) --
#     Compile all units, uses fpmake.
#
#   examples --
#     Compile examples and tools (inside examples/ subdirectory).
#     This compilation method uses our xxx_compile.sh Unix scripts,
#     and requires only pure FPC installation.
#     Lazarus is not required (LCL dependent examples are not compiled).
#     Note that you can also compile each example separately,
#     just execute directly appropriate xxx_compile.sh scripts.
#
#   examples-laz --
#     Compile examples and tools (inside examples/ subdirectory).
#     This compilation method uses our .lpi project files,
#     and compiles every program by the lazbuild utility.
#     Lazarus and FPC installation is required, and Lazarus must know
#     about the castle_* packages (compile them from Lazarus first).
#
#   clean --
#     Delete FPC 1.0.x Windows trash (*.ppw, *.ow), FPC trash, Delphi trash,
#     Lazarus trash (*.compiled),
#     binaries of example programs,
#     also FPC compiled trash in packages/*/lib/.
#
# Not-so-commonly-useful targets:
#
#   cleanmore --
#     Same as clean, but also delete:
#     - Emacs backup files (*~) and
#     - Delphi backup files (*.~???)
#     - pasdoc generated documentation in doc/pasdoc/ and doc/reference/
#     - closed-source libs you may have left in tools/build-tool/data
#     - QtCreator *.pro.user
#     This is a useful step when packing the release of CGE.
#
#   cleanall --
#     Same as cleanmore for now.
#     Intention is to remove *everything* that can be manually recreated,
#     even if somewhat hard, and clean editor backup.

# Hack for Cygwin, to avoid using Windows built-in "find" program.
#FIND:=/bin/find
FIND:=find

# compile ------------------------------------------------------------

.PHONY: all
all:
	$(MAKE) --no-print-directory build-using-fpmake
	tools/texture-font-to-pascal/texture-font-to-pascal_compile.sh
	tools/image-to-pascal/image-to-pascal_compile.sh
	tools/castle-curves/castle-curves_compile.sh
	tools/build-tool/castle-engine_compile.sh
	tools/sprite-sheet-to-x3d/sprite-sheet-to-x3d_compile.sh

.PHONY: build-using-fpmake
build-using-fpmake:
	fpc fpmake.pp
	@echo 'Running fpmake. If this fails saying that "rtl" is not found, remember to set FPCDIR environment variable, see http://wiki.freepascal.org/FPMake .'
# Workaround FPC >= 3.x problem (bug?) --- it ignores $FPCDIR, but --globalunitdir works
	if [ '(' -n "$(FPCDIR)" ')' -a \
	     '(' $(shell fpc -iV) '!=' '2.6.4' ')' -a \
	     '(' $(shell fpc -iV) '!=' '2.6.2' ')' ]; then \
	   ./fpmake --globalunitdir="$(FPCDIR)"; \
	else \
	   ./fpmake; \
	fi

# install / uninstall --------------------------------------------------------
#
# Note that this *does not* take care of installing the unit files.
# So it does not copy .ppu/.o files, it does not change your /etc/fpc.cfg
# or ~/.fpc.cfg. There are many ways how to install unit files,
# we leave this step up to you.
# See http://castle-engine.sourceforge.net/engine.php for documentation.
#
# Below we only take care of installing the tools.
# By default they are installed system-wide to /usr/local ,
# so you can run "make" followed by "sudo make install" to have the tools
# ready on a typical Unix system.

# Standard installation dirs, following conventions on
# http://www.gnu.org/prep/standards/html_node/Directory-Variables.html#Directory-Variables
PREFIX=$(DESTDIR)/usr/local
EXEC_PREFIX=$(PREFIX)
BINDIR=$(EXEC_PREFIX)/bin
DATAROOTDIR=$(PREFIX)/share
DATADIR=$(DATAROOTDIR)

.PHONY: install
install:
	install -d $(BINDIR)
	install tools/texture-font-to-pascal/texture-font-to-pascal $(BINDIR)
	install tools/image-to-pascal/image-to-pascal $(BINDIR)
	install tools/castle-curves/castle-curves $(BINDIR)
	install tools/build-tool/castle-engine $(BINDIR)
	install tools/sprite-sheet-to-x3d/sprite-sheet-to-x3d $(BINDIR)
#	cp -R tools/build-tool/data $(DATADIR)/castle-engine
	install -d  $(DATADIR)
	cd tools/build-tool/data/ && \
	  $(FIND) . -type f -exec install --mode 644 -D '{}' $(DATADIR)/castle-engine/'{}' ';'

.PHONY: uninstall
uninstall:
	rm -f  $(BINDIR)/texture-font-to-pascal \
	       $(BINDIR)/image-to-pascal \
	       $(BINDIR)/castle-curves \
	       $(BINDIR)/castle-engine \
	       $(BINDIR)/sprite-sheet-to-x3d
	rm -Rf $(DATADIR)/castle-engine

# Strip libraries that cannot be distributed in Debian package of CGE.
# - Some of them (some bundled Windows, Android libs) cannot be recompiled
#   automatically and easily for now (although they are open-source),
#   and are not of sufficient interest to the Debian users.
# - Some (Gradle) should be better used by depending on
#   the appropriate Debian package.
.PHONY: strip-precompiled-libraries
strip-precompiled-libraries:
	rm -Rf tools/build-tool/data/external_libraries/ \
	       tools/build-tool/data/android/integrated-services/sound/ \
	       tools/build-tool/data/android/integrated-services/ogg_vorbis/ \
	       tools/build-tool/data/android/base/gradle/ \
	       tools/build-tool/data/android/base/gradlew \
	       tools/build-tool/data/android/base/gradlew.bat \
	       tools/build-tool/data/android/integrated/gradle/ \
	       tools/build-tool/data/android/integrated/gradlew \
	       tools/build-tool/data/android/integrated/gradlew.bat

# examples and tools -----------------------------------------------------------

# Note that images/examples/fft_tests is not included here,
# and unit images/imagesfftw.pas is not included in fpmake.pp,
# because
# 1. it requires to compile FPC > 2.2.x, and we try to work also with earlier FPC.
# 2. to link the example, you need the fftw library. I don't want
#    to force everyone who wants to execute "make examples" to install
#    fftw library (especially since it's really not needed by my engine,
#    currently my fftw code is just for testing, it's not actually used
#    by our engine or any game for anything).

EXAMPLES_BASE_NAMES := \
  examples/audio/algets \
  examples/audio/alplay \
  examples/audio/doppler_demo \
  examples/audio/efx_demo \
  examples/tools/dircleaner \
  examples/tools/stringoper \
  examples/tools/castle_download \
  examples/tools/to_data_uri \
  examples/castlescript/castle_calculator \
  examples/castlescript/image_make_by_script \
  examples/images_videos/image_convert \
  examples/images_videos/dds_decompose \
  examples/images_videos/image_identify \
  examples/images_videos/image_paint \
  examples/images_videos/image_compare \
  examples/images_videos/simple_video_editor \
  examples/images_videos/drawing_modes_test \
  examples/joystick/joystick_demo \
  examples/fonts/test_font_break \
  examples/fonts/font_from_texture \
  examples/fonts/test_local_characters/test_local_characters \
  examples/fonts/html_text \
  examples/fonts/font_draw_over_image \
  examples/tiled/tiled_demo_standalone \
  examples/window/window_events \
  examples/window/window_menu \
  examples/window/window_gtk_mix \
  examples/window/multi_window \
  examples/curves/simplest_curve_read \
  examples/space_filling_curve/draw_space_filling_curve \
  examples/research_special_rendering_methods/radiance_transfer/radiance_transfer \
  examples/research_special_rendering_methods/radiance_transfer/precompute_radiance_transfer \
  examples/research_special_rendering_methods/radiance_transfer/show_sh \
  examples/research_special_rendering_methods/dynamic_ambient_occlusion/dynamic_ambient_occlusion \
  examples/terrain/terrain \
  examples/3d_rendering_processing/triangulate_demo \
  examples/3d_rendering_processing/placeholder_names \
  examples/3d_rendering_processing/multiple_viewports \
  examples/3d_rendering_processing/fog_culling \
  examples/3d_rendering_processing/animate_3d_model_by_code \
  examples/3d_rendering_processing/animate_3d_model_by_code_2 \
  examples/3d_rendering_processing/call_pascal_code_from_3d_model_script \
  examples/3d_rendering_processing/view_3d_model_advanced \
  examples/3d_rendering_processing/scene_manager_demos \
  examples/3d_rendering_processing/view_3d_model_basic \
  examples/3d_rendering_processing/build_3d_object_by_code \
  examples/3d_rendering_processing/build_3d_tunnel \
  examples/3d_rendering_processing/combine_multiple_x3d_into_one \
  examples/3d_rendering_processing/display_box_custom_shaders \
  examples/3d_rendering_processing/listen_on_x3d_events \
  examples/3d_rendering_processing/cars_demo \
  examples/3d_rendering_processing/render_3d_to_texture_and_use_as_quad \
  src/x3d/teapot/teapot_3d_to_pascal \
  src/x3d/nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal \
  examples/3d_sound_game/lets_take_a_walk \
  examples/resource_animations/resource_animations \
  examples/fps_game/fps_game \
  examples/2d_standard_ui/show_various_ui_controls/show_various_ui_controls \
  examples/2d_standard_ui/edit_test/edit_test \
  examples/2d_standard_ui/timer_test/timer_test \
  examples/2d_standard_ui/zombie_fighter/zombie_fighter \
  examples/mobile/simple_3d_demo/simple_3d_demo_standalone \
  tools/image-to-pascal/image-to-pascal \
  tools/texture-font-to-pascal/texture-font-to-pascal \
  tools/castle-curves/castle-curves \
  tools/sprite-sheet-to-x3d/sprite-sheet-to-x3d \
  examples/random_generator/globalrandom \
  examples/random_generator/random_speed_test \
  examples/random_generator/random_threads_test

EXAMPLES_LAZARUS_BASE_NAMES := \
  examples/audio/test_al_source_allocator \
  examples/audio/audio_player_scrubber/audio_player_scrubber \
  examples/lazarus/model_3d_viewer/model_3d_viewer \
  examples/lazarus/model_3d_with_2d_controls/model_3d_with_2d_controls \
  examples/lazarus/load_model_and_camera_manually/load_model_and_camera_manually \
  examples/lazarus/two_controls/two_controls \
  tests/test_castle_game_engine \
  src/library/castleengine \
  examples/library/lazarus_library_tester/cge_dynlib_tester \
  examples/random_generator/graphics_random_test \
  tools/build-tool/code/castle-engine

EXAMPLES_UNIX_EXECUTABLES := $(EXAMPLES_BASE_NAMES) \
  $(EXAMPLES_LAZARUS_BASE_NAMES)

EXAMPLES_WINDOWS_EXECUTABLES := $(addsuffix .exe,$(EXAMPLES_BASE_NAMES)) \
  $(addsuffix .exe,$(EXAMPLES_LAZARUS_BASE_NAMES))

EXAMPLES_MACOSX_APPS := $(addsuffix .app,$(EXAMPLES_BASE_NAMES)) \
  $(addsuffix .app,$(EXAMPLES_LAZARUS_BASE_NAMES))

EXAMPLES_RES_FILES := $(addsuffix .res,$(EXAMPLES_BASE_NAMES)) \
  $(addsuffix .res,$(EXAMPLES_LAZARUS_BASE_NAMES))

.PHONY: examples
examples:
	$(foreach NAME,$(EXAMPLES_BASE_NAMES),$(NAME)_compile.sh && ) true
# compile all examples with CastleEngineManifest.xml inside
	$(FIND) . -iname CastleEngineManifest.xml -execdir castle-engine $(CASTLE_ENGINE_TOOL_OPTIONS) compile ';'

.PHONY: examples-ignore-errors
examples-ignore-errors:
	$(foreach NAME,$(EXAMPLES_BASE_NAMES),$(NAME)_compile.sh ; ) true

.PHONY: cleanexamples
cleanexamples:
	rm -f $(EXAMPLES_UNIX_EXECUTABLES) $(EXAMPLES_WINDOWS_EXECUTABLES) $(EXAMPLES_RES_FILES)
	rm -Rf $(EXAMPLES_MACOSX_APPS)

.PHONY: examples-laz
examples-laz:
	lazbuild packages/castle_base.lpk
	lazbuild packages/castle_window.lpk
	lazbuild packages/castle_components.lpk
	$(foreach NAME,$(EXAMPLES_BASE_NAMES) $(EXAMPLES_LAZARUS_BASE_NAMES),lazbuild $(NAME).lpi && ) true

# Compile only Lazarus-specific examples (that depend on LCL)
.PHONY: examples-only-laz
examples-only-laz:
	lazbuild packages/castle_base.lpk
	lazbuild packages/castle_window.lpk
	lazbuild packages/castle_components.lpk
	$(foreach NAME,$(EXAMPLES_LAZARUS_BASE_NAMES),lazbuild $(NAME).lpi && ) true

# cleaning ------------------------------------------------------------

.PHONY: clean cleanmore cleanall

clean: cleanexamples
	$(FIND) . -type f '(' -iname '*.ow'  -or -iname '*.ppw' -or -iname '*.aw' -or \
	                   -iname '*.o'   -or -iname '*.ppu' -or -iname '*.a' -or \
			   -iname '*.or'  -or \
			   -iname '*.rsj' -or \
			   -iname '*.compiled' -or \
			   -iname '*.lps' -or \
			   -iname '*.libimp*.a' -or \
			   -iname '*.apk' -or \

=== doc/pasdoc/Makefile ===
# Main targets to gen final docs ----------------------------------------

.PHONY: default html pdf ps rtf latex

# html and pdf are two most useful versions of documentation,
# shown on [http://castle-engine.sourceforge.net/reference.php]
# Later: pdf now removed, useless and ugly.
default: html

# Run "make" in logo/ first,
# if you have inkscape installed,
# and you want to regenerate logo from png.
#
# Run "make" in html-parts/ first,
# if you have cge-www repository (https://github.com/castle-engine/cge-www)
# cloned and placed as a sibling to castle-engine, in ../../../cge-www/

html:
	./mk_docs.sh html
	rm -Rf ../reference/html
	mv html ../reference/
	cp logo/castle_game_engine_icon.png ../reference/

# Just some shortcuts to "Helpful targets" below
pdf: latex/docs.pdf
ps: latex/docs.ps
rtf: latex2rtf/docs.rtf
latex: latex/docs.tex

# Helpful targets to gen docs ----------------------------------------

latex2rtf/docs.tex:
	./mk_docs.sh latex2rtf

latex2rtf/docs.rtf: latex2rtf/docs.tex
	cd latex2rtf; latex2rtf docs.tex

latex/docs.tex:
	./mk_docs.sh latex

TEX_BATCH_OPTS := --file-line-error-style -interaction=nonstopmode

latex/docs.dvi: latex/docs.tex
	-cd latex; latex $(TEX_BATCH_OPTS) docs.tex
	-cd latex; latex $(TEX_BATCH_OPTS) docs.tex

# At the end of pdf generating, we clean useless junk
# (because it's quite large, and I may want to upload latex/
# dir to WWW page of my units)
latex/docs.pdf: latex/docs.tex
	-cd latex; pdflatex $(TEX_BATCH_OPTS) docs.tex
	-cd latex; pdflatex $(TEX_BATCH_OPTS) docs.tex
	rm -f latex/docs.aux \
	      latex/docs.log \
	      latex/docs.out \
	      latex/docs.toc

latex/docs.ps: latex/docs.dvi
	cd latex; dvips docs.dvi -o docs.ps

# Cleaning ------------------------------------------------------------

.PHONY: clean-cache clean

clean-cache:
	rm -fR cache/

clean: clean-cache
	rm -Rf html/ latex/ latex2rtf/ ../reference/

# upload ---------------------------------------------------------------------

SF_USERNAME=kambi
SF_HOST=web.sourceforge.net
SF_PATH=/home/project-web/castle-engine/htdocs/apidoc/

SF_CONNECT=$(SF_USERNAME),castle-engine@$(SF_HOST):$(SF_PATH)
SCP_OPTIONS=

# Prepare and upload all the stuff referenced under
# [http://castle-engine.sourceforge.net/reference.php].
# Uploads as tar.gz and unpacks on server, this is *much* faster than
# uploading separate HTML files.
.PHONY: upload
upload: clean html
	rm -Rf ../reference/html
	mv ../reference/ html
	tar czvf html.tar.gz html
	scp $(SCP_OPTIONS) -r html.tar.gz $(SF_CONNECT)
	./sf_upload_finalize.sh $(SF_USERNAME) $(SF_PATH)

=== examples/2d_dragon_spine_game/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

MODE:=debug

.PHONY: compile
compile:
	castle-engine --mode=$(MODE)  compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: win32
win32:
	castle-engine --mode=$(MODE) package --os=win32 --cpu=i386

.PHONY: linux
linux:
	castle-engine --mode=$(MODE) package --os=linux --cpu=i386

.PHONY: src
src:
	castle-engine --mode=$(MODE) package-source

.PHONY: android
android:
	castle-engine --mode=$(MODE) package --os=android --cpu=arm --fast
	castle-engine install --os=android --cpu=arm
	castle-engine run --os=android --cpu=arm

.PHONY: android-release
android-release:
	castle-engine clean
	$(MAKE) android MODE=release

.PHONY: ios
ios:
	castle-engine --mode=$(MODE) package --target=iOS --fast

.PHONY: ios-release
ios-release:
	castle-engine clean
	$(MAKE) ios MODE=release

=== examples/3d_sound_game/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

.PHONY: standalone
standalone:
	castle-engine compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

=== examples/fixed_camera_game/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

MODE:=debug

.PHONY: standalone
standalone:
	castle-engine --mode=$(MODE) compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: win32
win32:
	castle-engine --mode=$(MODE) package --os=win32 --cpu=i386

.PHONY: linux32
linux32:
	castle-engine --mode=$(MODE) package --os=linux --cpu=i386

.PHONY: linux64
linux64:
	castle-engine --mode=$(MODE) package --os=linux --cpu=x86_64

.PHONY: src
src:
	castle-engine --mode=$(MODE) package-source

.PHONY: android
android:
	castle-engine --mode=$(MODE) package --os=android --cpu=arm --fast
	castle-engine install --os=android --cpu=arm
	castle-engine run --os=android --cpu=arm

.PHONY: android-release
android-release:
	castle-engine clean
	$(MAKE) android MODE=release

.PHONY: ios
ios:
	castle-engine --mode=$(MODE) package --target=iOS --fast

.PHONY: ios-release
ios-release:
	castle-engine clean
	$(MAKE) ios MODE=release

=== examples/fonts/Makefile ===
# This uses file_to_pascal_string, a trivial program
# from the pasdoc [http://pasdoc.sf.net/] project, see
# [https://svn.code.sf.net/p/pasdoc/code/trunk/source/tools/file_to_pascal_string.dpr]

ALL_TARGETS := html_text_demo.html.inc

default: $(ALL_TARGETS)

clean:
	rm -f $(ALL_TARGETS)

%.inc: %
	file_to_pascal_string $< $@

=== examples/portable_game_skeleton/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

.PHONY: standalone
standalone:
	castle-engine compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: release-src
release-src:
	castle-engine package-source

.PHONY: release-win32
release-win32:
	castle-engine package --os=win32 --cpu=i386

.PHONY: release-linux
release-linux:
	castle-engine package --os=linux --cpu=i386

.PHONY: release-linux64
release-linux64:
	castle-engine package --os=linux --cpu=x86_64

.PHONY: android
android:
	castle-engine package --os=android --cpu=arm --fast --mode=debug
	castle-engine install --os=android --cpu=arm
	castle-engine run --os=android --cpu=arm

.PHONY: release-android
release-android:
	castle-engine package --os=android --cpu=arm --mode=release
	castle-engine install --os=android --cpu=arm

=== doc/pasdoc/html-parts/Makefile ===
# Use this Makefile to generate HTML files
# for inclusion in the HTML API documentation.
#
# It requires
# - command-line php
# - cge-www repository (https://github.com/castle-engine/cge-www)
#   cloned and placed as a sibling to castle-engine, in ../../../../cge-www/

ALL_TARGETS := body-end.html body-begin.html head.html

.PHONY: default
default: $(ALL_TARGETS)

.PHONY: clean
clean:
	rm -f $(ALL_TARGETS)

%.html: %.php
	php $< > $@

=== doc/pasdoc/logo/Makefile ===
.PHONY: default
default: castle_game_engine_icon.png

.PHONY: clean
clean:
	rm -f castle_game_engine_icon.png

castle_game_engine_icon.png: castle_game_engine_icon.svg
	inkscape $< \
	  --export-width=256 \
	  --export-height=256 \
	  --export-background=white \
	  --export-background-opacity=0 \
	  --export-png=$@

# Unused anymore.
# This made sense cause old IE didn't interpret alpha channel in PNG Ok.
# Fortunately, IE is dead now:)
#
# castle_game_engine_icon_nontransparent.png: castle_game_engine_icon.svg
# 	inkscape $< \
# 	  --export-width=256 \
# 	  --export-height=256 \
# 	  --export-background=white \
# 	  --export-background-opacity=255 \
# 	  --export-png=$@

=== examples/2d_standard_ui/show_various_ui_controls/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

MODE:=debug

.PHONY: standalone
standalone:
	castle-engine --mode=$(MODE) compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: android
android:
	castle-engine --mode=$(MODE) package --os=android --cpu=arm
	castle-engine install --os=android --cpu=arm
	castle-engine run --os=android --cpu=arm

.PHONY: ios
ios:
	castle-engine --mode=$(MODE) package --target=iOS

=== examples/2d_standard_ui/zombie_fighter/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

MODE:=debug

.PHONY: standalone
standalone:
	castle-engine --mode=$(MODE) compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: android
android:
	castle-engine --mode=$(MODE) package --os=android --cpu=arm
	castle-engine install --os=android --cpu=arm
	castle-engine run --os=android --cpu=arm

=== examples/fonts/test_local_characters/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

.PHONY: standalone
standalone:
	castle-engine compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: release-src
release-src:
	castle-engine package-source

.PHONY: release-win32
release-win32:
	castle-engine package --os=win32 --cpu=i386

.PHONY: release-linux
release-linux:
	castle-engine package --os=linux --cpu=i386

.PHONY: release-linux64
release-linux64:
	castle-engine package --os=linux --cpu=x86_64

.PHONY: release-android
release-android:
	castle-engine package --os=android --cpu=arm
	castle-engine install --os=android --cpu=arm

=== debian/changelog ===
castle-game-engine (6.4+dfsg1-5) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Abou Al Montacir ]
  * Fix compilation with FPC 3.2.0. (Closes: Bug#968120)
    Thanks to Michalis Kamburelis
  * Fixed issue with thread manager initialization in fpmake with FPC 3.2.0.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Mon, 10 Aug 2020 17:24:31 +0200

castle-game-engine (6.4+dfsg1-4) unstable; urgency=medium

  [ Olivier Tilloy ]
  * Update runtime dependency on the transitional dummy ttf-dejavu-core
    (which was dropped from unstable) to fonts-dejavu-core (Closes: #961602)

 -- Paul Gevers <elbrus@debian.org>  Thu, 04 Jun 2020 18:41:09 +0200

castle-game-engine (6.4+dfsg1-3) unstable; urgency=medium

  * Add inkscape-dropped--export-png.patch, thanks Lucas Nussbaum for
    reporting Closes: #959582
  * d/control: Add versioned B-D on inkscape
  * d/control: use canonical Vcs-Browser
  * Bump compat (via debhelper-compat) to 13
  * Add d/castle-game-engine-src.lintian-overrides as the issue is only
    with packages build with cge
  * Add lintian override for dh-exec-subst-unknown-variable
  * Drop embedded ttf files that can be (and are) linked from packages
  * Bump standards

 -- Paul Gevers <elbrus@debian.org>  Tue, 05 May 2020 21:48:26 +0200

castle-game-engine (6.4+dfsg1-2) unstable; urgency=medium

  * Fix arch:all target for stand-alone builds (Closes: #890110)

 -- Paul Gevers <elbrus@debian.org>  Sun, 11 Feb 2018 20:39:37 +0100

castle-game-engine (6.4+dfsg1-1) unstable; urgency=medium

  * New upstream release
    - Drop reproducible build patch (applied upstream)
  * Drop previous hack to set FPCDIR now fpc is fixed
  * Swith to shorthand dh and adapt d/rules
  * Fix links to fonts in cge-src package, broken since 6.2+dfsg1-2
  * Bump Build-Depends version on pasdoc

 -- Paul Gevers <elbrus@debian.org>  Sat, 10 Feb 2018 20:20:23 +0100

=== debian/control ===
Source: castle-game-engine
Section: misc
Priority: optional
Maintainer: Pascal Packaging Team <pkg-pascal-devel@lists.alioth.debian.org>
Uploaders:
 Abou Al Montacir <abou.almontacir@sfr.fr>,
 Paul Gevers <elbrus@debian.org>
Standards-Version: 4.5.0
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 fonts-dejavu,
 fp-compiler,
 fp-units-base,
 fp-units-db,
 fp-units-fcl,
 fp-units-gfx,
 fp-units-gtk2,
 fp-units-misc,
 fp-units-multimedia,
 fp-units-net,
 fp-utils (>= 2.6.2),
 help2man,
 libatk1.0-dev,
 libcairo2-dev,
 libfreetype6-dev,
 libgdk-pixbuf2.0-dev,
 libgtk2.0-dev,
 libgtkglext1-dev,
 libpango1.0-dev,
 xcftools,
Build-Depends-Indep:
 inkscape (>= 1.0~),
 pasdoc (>= 0.15.0~),
Vcs-Git: https://salsa.debian.org/pascal-team/castle-game-engine.git
Vcs-Browser: https://salsa.debian.org/pascal-team/castle-game-engine
Homepage: https://castle-engine.sourceforge.io/engine.php
Rules-Requires-Root: no

Package: fp-units-castle-game-engine
Architecture: any
Built-Using: fonts-dejavu (= ${dejavu:version})
Depends:
 ${fpc-abi:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 castle-game-engine-doc,
 fpc,
 lazarus
Suggests:
 castle-game-engine-src,
 gradle,
Description: Castle Game Engine - 3D game engine for FreePascal / Lazarus
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains the FPC units and the auxiliary tools castle-curves,
 castle-engine, image-to-pascal, sprite-sheet-to-x3d, and
 texture-font-to-pascal.
 .
 This package suggests the gradle package. Gradle is only necessary if one
 wants to build Android applications, otherwise one can ignore that
 suggestion. Note that, in order to create Android applications, one will also
 need the Android SDK and NDK, and FPC cross-compiler, see
 https://github.com/castle-engine/castle-engine/wiki/Android.

Package: castle-game-engine-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
 fonts-droid-fallback,
 fonts-dejavu-core,
Suggests:
 castle-game-engine-src,
 fp-units-castle-game-engine,
 libjs-jquery,
Description: Castle Game Engine - Developer's Documentation
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains documentation.

Package: castle-game-engine-src
Section: doc
Architecture: all
Built-Using: fonts-dejavu (= ${dejavu:version})
Depends:
 fonts-dejavu,
 ${misc:Depends}
Recommends:
 castle-game-engine-doc,
 fpc,
 lazarus
Suggests:
 fp-units-castle-game-engine
Description: Castle Game Engine - Source code for Lazarus integration
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains source code for integration with Lazarus RAD IDE.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for Castle Game Engine

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk
export DH_ALWAYS_EXCLUDE := COPYING:LICENSE
export LANG:=C

# Documentation type to use chm/html
ifeq (${DEBDOCTYPE},)
DOCTYPE=html
# HTML Converter chmdocs or htmldocs for (default)
CONVERTER=${DOCTYPE}docs
else
DOCTYPE=${DEBDOCTYPE}
CONVERTER=${DOCTYPE}docs
endif
# Define FPC
ifndef FPC
FPC=/usr/bin/fpc
endif
# Set FPCVER
FPCVER=$(shell ${FPC} -iV)

CPU_TARGET?=$(shell ${FPC} -iTP)
OS_TARGET?=$(shell ${FPC} -iTO)
FPCTARGET=${CPU_TARGET}-${OS_TARGET}
# Used in dh-exec enhanced files
export CGE_VERSION=$(shell echo ${DEB_VERSION_UPSTREAM} | sed -e 's/^\([0-9\.]*\).*/\1/')
DEB_BUILD=$(lastword $(subst -, ,${DEB_VERSION}))
ifndef PACKAGESUFFIX
PACKAGESUFFIX=-${CGE_VERSION}
endif
# Get directories
INSTALL_DIR=$(CURDIR)/debian/tmp
LIB_DIR=${INSTALL_DIR}/usr/lib/${DEB_SOURCE}/${CGE_VERSION}
SRC_DIR=$(CURDIR)/debian/src/${DEB_SOURCE}-${CGE_VERSION}
UNITS_DIR=${INSTALL_DIR}/usr/lib/${DEB_HOST_MULTIARCH}/fp-units-${FPCVER}/${DEB_SOURCE}-${CGE_VERSION}
TMP_DIR=${INSTALL_DIR}/tmp
# Get utils
ifndef MKDIR
MKDIR=mkdir -p
endif
ifndef CP
CP=cp -Rfpl
endif
RM:=rm -rf

#export DH_VERBOSE=1

%:
	dh ${@}

override_dh_auto_clean:
	${MAKE} cleanall
	$(MAKE) strip-precompiled-libraries
	dh_auto_clean

prepare-source: prepare-source-stamp
prepare-source-stamp:
	# Building Pascal style font file first while making sure that
	# no unit or object files polute the source tree
	${MKDIR} ${TMP_DIR}
	${FPC} -FE${TMP_DIR}  @castle-fpc.cfg tools/texture-font-to-pascal/texture-font-to-pascal.lpr
	cd src/fonts ; PATH=${PATH}:${TMP_DIR} ./mk_fonts.sh

	# cge embeds some images from xcf via png into Pascal source files
	# First we need to create the pngs
	for pngfile in $$(grep \\\.png\$$ debian/clean) ; do xcf2png $${pngfile%.png}.xcf -o $${pngfile} ; done
	# Then we build the helper function
	${FPC} -FE${TMP_DIR} -dRELEASE @castle-fpc.cfg tools/image-to-pascal/image-to-pascal.lpr
	# To finally convert png files to pas file
	PATH=${TMP_DIR} ${MAKE} -C src/ui/opengl/gui-images all

	# Upstream source contains auto-generated include files. Let's generate
	# them again.
	${FPC} -FE${TMP_DIR} -dRELEASE @castle-fpc.cfg src/x3d/nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr
	cd src/x3d/nodes_specification/x3d-nodes-to-pascal ; \
		PATH=${TMP_DIR} x3d-nodes-to-pascal ../components/*.txt

	# For reproducible builds we need to make sure the timestamp of the just
	# created files is fixed. Let's use SOURCE_DATE_EPOCH for that. For the
	# future, this needs to be even smarter, because now every Debian revision
	# will require all the reverse dependencies generating ppu files to be
	# rebuild.
	touch --no-dereference --date="@$${SOURCE_DATE_EPOCH}" \
		src/x3d/auto_generated_node_helpers/*.inc \
		src/fonts/castletexturefont_*.pas \
		src/ui/opengl/castlecontrolsimages.*

	touch prepare-source-stamp

# Annoying thing is we need to do this very early to save lots of overhead. If
# it can be done on a clean tree, right after prepare-source we don't need
# cleaning, right.
install-source: install-source-stamp
install-source-stamp:
	@echo "--- Copying the source code"
	dh_testdir
	${MKDIR} ${SRC_DIR}
	${CP} -t ${SRC_DIR} \
		$(CURDIR)/src/*
	find $(SRC_DIR) -name '*.bmp' -exec chmod 644 '{}' ';'
	find ${SRC_DIR} -empty -delete
	touch install-source-stamp

override_dh_auto_build-arch: prepare-source install-source
	# Build the real engine
	${MAKE} all
	# Generate man pages
	${MAKE} -C doc/man/man1

override_dh_auto_test-arch:
	# Command basically copied from tests/compile_console.sh while
	# making sure that no unit or object files polute the source tree
	${FPC}  -gh -dDEBUG -dTEXT_RUNNER -dNO_WINDOW_SYSTEM \
		-Fuexamples/research_special_rendering_methods/shadow_fields/ \
		-Fuexamples/curves_surfaces/ \
		-FE${TMP_DIR} \
		@castle-fpc.cfg tests/test_castle_game_engine.lpr
	# cd is needed to find the data files
	cd tests ; ${TMP_DIR}/test_castle_game_engine -a

override_dh_auto_install-arch:
	# Install units
	${MKDIR} ${UNITS_DIR}
	${CP} -t ${UNITS_DIR} units/${FPCTARGET}/*
	# Mark package as manually compilable and install them
	for package in $$(find * -name '*.lpk') ; \
	do \
		pkgDir=$$(dirname "${LIB_DIR}/$${package}") ; \
		${MKDIR} "$${pkgDir}" ; \
		sed -e 's@\(\W*\)<CompilerOptions>.*@\1<AutoUpdate Value="Manually"/>\n&@' \
		    -e "s@\.\./src/@$$(relpath ${SRC_DIR} $${pkgDir})/@g" \
		    -e "s@\(\W*\)<UnitOutputDirectory .*@<UnitOutputDirectory Value=\"$$(relpath ${UNITS_DIR} $${pkgDir})\"/>@" \
		    "$${package}" > "${LIB_DIR}/$${package}" ; \
	done
	# Call upstream install target for the tools
	${MAKE} PREFIX=${INSTALL_DIR}/usr install
	find ${INSTALL_DIR} -empty -delete

override_dh_auto_build-indep: prepare-source install-source
	@echo "--- Building Documentation"
	# Create logo first, before generating documentation
	${MAKE} -C doc/pasdoc/logo
	${MAKE} -C doc/pasdoc ${DOCTYPE}
	# pasdoc create a jquery file, but we link from jquery instead
	${RM} doc/reference/tipuesearch/jquery.min.js

override_dh_auto_install-indep: install-source

override_dh_installdocs:
	dh_installdocs -X.in

override_dh_install:
	# tmp/tmp is used for the testsuite
	dh_install -Xtmp/tmp/

override_dh_compress-indep:
	dh_compress -X.pdf

override_dh_gencontrol:
	dh_gencontrol -- -V"dejavu:version=$$(dpkg-query --show fonts-dejavu | awk '{print $$2}')"

.PHONY:prepare-source install-source

## castle-game-engine 7.0~alpha.1%2Bdfsg

=== debian/changelog ===
castle-game-engine (7.0~alpha.1+dfsg-8) unstable; urgency=medium

  * Updated CI tests script to fit CGE units new installation directory.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 06 Feb 2022 21:32:05 +0100

castle-game-engine (7.0~alpha.1+dfsg-7) unstable; urgency=medium

  * Fixed CGE compilation on ppc64el architecture.
    Provide FPCDIR to make file so that it could build with right RTL.
  * Moved CGE units to the right FPC units directory.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 06 Feb 2022 11:22:21 +0100

castle-game-engine (7.0~alpha.1+dfsg-6) unstable; urgency=medium

  * Prevent CI tests from failing due to test writes to standard error file.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sat, 05 Feb 2022 11:42:05 +0100

castle-game-engine (7.0~alpha.1+dfsg-5) unstable; urgency=medium

  * Moved CI tests outside rules file.
    Disabled CI tests result for armel until FPC gets fixed.
  * Added tests failing on armel to expected failures on that architecture.
    (Closes: Bug#1002961)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Fri, 04 Feb 2022 21:54:07 +0100

castle-game-engine (7.0~alpha.1+dfsg-4) unstable; urgency=medium

  * Fixed files path in copyright file.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sat, 18 Dec 2021 00:33:26 +0100

castle-game-engine (7.0~alpha.1+dfsg-3) unstable; urgency=medium

  * New upstream release 7.0-alpha.1.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Mon, 01 Nov 2021 10:53:49 +0100

castle-game-engine (7.0~alpha.1+dfsg-2) experimental; urgency=medium

  * Force dependency on imagemagick-6.q16 in order to fix FTBFS.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 02 May 2021 17:20:42 +0200

castle-game-engine (7.0~alpha.1+dfsg-1) experimental; urgency=medium

  [ Paul Gevers ]
  * New upstream version 7.0-alpha.1
  * Refresh patches
  * Use imagemagick instead of xcf2png for icon conversion (Closes: #982500)
  * Update d/changelog for release 6.4+dfsg1-6
  * Drop deprecated Build-Depends: libgtkglext1-dev
  * Fix FTBFS part 1: b9faa3bc380367eb72de1164f6cc366353a7c1ba.patch
  * Update d/clean with new list of generated pngs + one folder removed
  * Fix FTBFS part 2: debian/patches/51b053087af6ebc9904adf8bab64177ef5cadd1c.patch
  * d/rules: fix location of x3d-nodes-to-pascal

  [ Abou Al Montacir ]
  * Fixed multi-lines build rules in devian/rules file.
  * Update changelog for 7.0-alpha.1-1 release
  * Added libgl1 to build dependencies.
  * Added upstream patch to fix warning when building API docs.
    Thanks to Michalis Kamburelis <michalis.kambi@gmail.com>
  * Force using PasDoc newer than 0.16.0.
  * Update changelog for 7.0-alpha.1-1 release
  * Fixed tests compilation.
    Thanks to Michalis Kamburelis <michalis.kambi@gmail.com>
  * Fixed watch file.
  * Filter out binary shared object libraries when importing sources.
  * New upstream version 7.0~alpha.1+dfsg

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 02 May 2021 12:20:38 +0200

castle-game-engine (6.4+dfsg1-7) unstable; urgency=medium

  * Improve built pngs by using upstream commit bac2e014

 -- Paul Gevers <elbrus@debian.org>  Thu, 18 Feb 2021 11:16:52 +0100

castle-game-engine (6.4+dfsg1-6) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints. + castle-game-engine-doc,
    castle-game-engine-src: Add Multi-Arch: foreign.

  [ Paul Gevers ]
  * d/watch: update for pre-releases
  * Use imagemagick instead of xcf2png for icon conversion (Closes:
    #982500)

 -- Paul Gevers <elbrus@debian.org>  Thu, 11 Feb 2021 10:29:56 +0100
